/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.plil.sio.persistence.jdbc;

import fr.plil.sio.persistence.api.Right;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import javax.sql.DataSource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

/**
 *
 * @author msahmane
 */
@Repository
public class RightRepositoryJdbc implements RightRepository {
    
    private static final Logger logger = LoggerFactory.getLogger(GroupRepository.class);

    @Autowired
    private DataSource dataSource;

    @Override
    public List<Right> findByName(String name) {
        Statement stmt = null;
        ResultSet rs = null;
        List<Right> list = new ArrayList<>();
        try {
            stmt = dataSource.getConnection().createStatement();
            rs = stmt.executeQuery("SELECT * FROM RIGHT_T WHERE NAME_R = \'" + name + "\'");
            if (rs.next()) {
                logger.debug("found group " + name);
                Right right = new Right();
                right.setId(rs.getLong("RIGHT_ID"));
                right.setName(rs.getString("NAME_R"));
                list.add(right);
                return list;
            } else {
                logger.debug("not found " + name);
                return list;
            }
        } catch (SQLException e) {
            throw new UnsupportedOperationException("sql exception", e);
        } finally {
            try {
                if (rs != null) {
                    rs.close();
                }
                if (stmt != null) {
                    stmt.close();
                }
            } catch (SQLException e) {
                throw new UnsupportedOperationException("sql exception during close", e);

            }
        }
    }

    @Override
    public void save(Right right) {
        Statement stmt = null;
        ResultSet rs = null;
        try {
            stmt = dataSource.getConnection().createStatement();
            stmt.executeUpdate("INSERT INTO RIGHT_T (NAME_R) VALUES (\'" + right.getName() + "\')",
                    Statement.RETURN_GENERATED_KEYS);
            rs = stmt.getGeneratedKeys();
            if (rs.next()) {
                right.setId(rs.getLong(1));
            } else {
                throw new UnsupportedOperationException("default in key access");
            }
        } catch (SQLException e) {
            throw new UnsupportedOperationException("sql exception", e);
        } finally {
            try {
                if (rs != null) {
                    rs.close();
                }
                if (stmt != null) {
                    stmt.close();
                }
            } catch (SQLException e) {
                throw new UnsupportedOperationException("sql exception during close", e);
            }
        }

    }

    @Override
    public void delete(Long id) {
        Statement stmt = null;
        ResultSet rs = null;
        try {
            stmt = dataSource.getConnection().createStatement();
            stmt.executeUpdate("DELETE FROM RIGHT_T WHERE RIGHT_ID="+id,
                    Statement.RETURN_GENERATED_KEYS);
            rs = stmt.getGeneratedKeys();
       
        } catch (SQLException e) {
            throw new UnsupportedOperationException("sql exception", e);
        } finally {
            try {
                if (rs != null) {
                    rs.close();
                }
                if (stmt != null) {
                    stmt.close();
                }
            } catch (SQLException e) {
                throw new UnsupportedOperationException("sql exception during close", e);
            }
        }
    }
    
    @Override
    public Right findOne(Long id){
        Statement stmt = null;
        ResultSet rs = null;
        try{
            stmt = dataSource.getConnection().createStatement();
            rs = stmt.executeQuery("SELECT * FROM RIGHT_T WHERE RIGHT_ID = "+id);            
            if (rs.next()) {
                Right right = new Right();
                right.setId(rs.getLong("RIGHT_ID"));
                right.setName(rs.getString("NAME_R"));   
                
                return right;
            }
            return null;
        }catch(SQLException e){
            throw new UnsupportedOperationException("sql exception", e);
        }finally{
            try{
                if(rs !=null){
                    rs.close();
                }
                if(stmt != null){
                    stmt.close();
                }
            }catch(SQLException e){
                throw new UnsupportedOperationException("sql exception during close", e);
            }
        }
    }
    
}
